import zmq
from pynovatec.events import EventListener,EventRegisterListener,EventPost,EventUnregisterListener, Events
from qc_events import QCStateChange,SensorDataPoint,QCEvents,SensorDataCollectionComplete, SensorDataCalibrationComplete
from qc_events import QCListener
import threading
from ZmqConvert import get_zmq_data_format2


class ZmqDataEvents(Events):
    event_name='test'
    def __init__(self,data,*args,**kwargs):
        new_data = {
            'event_name':self.event_name,
            'data': data
        }
        super().__init__(new_data,*args,**kwargs)


class ZmqEventPoster(threading.Thread):
    def __init__(self,*args,host="127.0.0.1",port=7778,**kwargs):
        self.host=host
        self.port = port
        threading.Thread.__init__(self,target=self.run)
        self.keepRunning = True


    def run(self):
        self.zmq_stream_data()

    def stop(self):
        self.keepRunning = False

    def handle_message(self,string):
        data=get_zmq_data_format2(string.decode())
        EventPost(ZmqDataEvents(data))

    def zmq_stream_data(self):
        context = zmq.Context()
        socket = context.socket(zmq.SUB)

        print("Collecting data from port %s..." % self.port)
        socket.connect ("tcp://127.0.0.1:%s" % self.port)
        socket.subscribe("")
        while self.keepRunning:
            string = socket.recv()
            self.handle_message(string)
            #print(f"RECV: {string}")
            #select_data_stream(string.decode())

        print("Shutting down zmq stream...")
        socket.close()
        context.term()
