import os
from os import getenv as env
from dotenv import load_dotenv
import getmac

try:
    env_file=os.path.join(os.getcwd(),".env")
    load_dotenv(env_file)
    load_dotenv('/etc/os-release')
except Exception as e:
    print("Config Exception...",str(e));
    pass
config = {
        'server': {
                "host": env("APP_HOST", "0.0.0.0"),
                "port": env("APP_PORT", 5081),
		"username":"user",
		"password":"pass"
        },
        'qc': {
                'mqtt': {
                        "host": env("MQTT_HOST", "mqtt-data.machinesense.com"),
                        "port": env("MQTT_PORT", 8883),
                },
                'ping': {
                        "host": env("PING_HOST", "machinesense.com")
                }
        },
        'wireless': {
                "device": env("WIRELESS_INTERFACE", "wlan1"),
                "interface": env("WIRELESS_INTERFACE", "wwan"),
                "radio": env("WIRELESS_RADIO", "radio1"),
        },
        'ethernet': {
                "device": env("ETHERNET_INTERFACE", "eth0"),
                "interface": env("ETHERNET_INTERFACE", "lan"),
        },
        'data_stream': {
                "zmq_host": env("DATA_STREAM_ZMQ_HOST","localhost"), 
                "zmq_port": env("DATA_STREAM_ZMQ_PORT","7778")
        },
        'paths': {
                "json": env("PATH_JSON","/opt/novatec/data/slave/json_data")
        },
        'files': {
                "sensor_boards": env("FILES_SENSOR_BOARDS","sensor_boards.json")
        },
        'system': {
                'interface':env("SYSTEM_IFACE",'eth0'),
                'mac': env("SYSTEM_MAC"),
                'uuid': env("SYSTEM_UUID"),
        }
}

if not config['system']['mac']:
    config['system']['mac'] = getmac.get_mac_address(interface=config['system']['interface']).strip()
if not config['system']['uuid']:
    config['system']['uuid']=config['system']['mac'].replace(':','')


