from quart import Quart, jsonify, request, abort
from pynovatec.helpers.system import reboot_device
import os
from werkzeug.utils import secure_filename
import subprocess
from getmac import get_mac_address as gma
import time
from cerberus import Validator
from . import controllers

ota_file_path = "/tmp"
update_script= "/usr/src/run/scripts/ota_update.sh"

async def buildErrorResponse(error):
  return {"success":False,"error":{"message":str(error)}}

@controllers.route('/datahubUpdate', methods=['POST'])
async def datahubUpdate():
    try:
        theform = await request.form
        # incoming_mac = theform.get("mac")
        response = upload_file(request, ota_file_path)
        print("Response: ",response)
        
    except:
        raise


def upload_file(req, upload_path):
    try:
        response = {"success": False, "message": ""}
        if 'file' not in req.files:
            response["message"] = "No file found in the request"
        else:
            file = req.files['file']
            if not file:
                response["message"] = "Invalid file in request"
            elif file.filename == '':
                response["message"] = "No file sent in the request"
            elif not allowed_file(file.filename):
                response["message"] = "File has invalid extension"
            else:
                filename = secure_filename(file.filename)
                file.save(os.path.join(upload_path, filename))
                response['filename'] = file.filename
                response["success"] = True
        return response
    except:
        raise
