

import os
import traceback


def bp_import(app,prefix,module_name):
    try:
        module = __import__(module_name,fromlist=['bp'])
        with app.app_context():
            app.register_blueprint(module.bp,url_prefix="/" + prefix)
    except Exception as e:
        print("Error loading module: ",module_name)
        print(e)
        traceback.print_exc()

def module_import(app,prefix,module_name):
    try:
        module = __import__(module_name,fromlist=['module_init'])
        module.module_init(app)
    except Exception as e:
        print("Error loading module: ",module_name)
        print(e)
        traceback.print_exc()

def load_modules(app,module_path=None):
    module_dir = os.path.dirname(__file__) + "/modules"

    for module in os.listdir(module_dir):
        modpath=module_dir + "/" + module
        if (os.path.isdir(modpath)):
            module_name = "modules." + module
            module_import(app,module,module_name)




